Zen API

- Home
- Topics
- Types
- Files

All Classes Files Functions Variables Typedefs Friends Macros Modules Pages
Public Member Functions
kArray3 Class Reference
kApi/Data

## Description

Represents a 3D array.

The kArray3 class represents a 3D array of objects or values. The kArray3 constructor accepts arguments that determine the array item type (kType) and array dimension lengths.

For arrays that contain objects (e.g. kImage) as opposed to values (e.g. k32s), the objects are not automatically destroyed when the array is destroyed. To recursively destroy both the array and the array items, use kObject_Dispose.

kArray3 supports the kObject_Clone, kObject_Dispose, and kObject_Size methods.

kArray3 supports the kdat5 and kdat6 serialization protocols.

Inheritance diagram for kArray3:

## Public Member Functions
kStatus | kArray3_Allocate (kArray3 array, kType itemType, kSize length0, kSize length1, kSize length2)
| Reallocates the internal array item buffer. More...
kStatus | kArray3_Assign (kArray3 array, kArray3 source)
| Performs a shallow copy of the source array. More...
void * | kArray3_At (kArray3 array, kSize index0, kSize index1, kSize index2)
| Returns a pointer to the specified item in the array. More...
kStatus | kArray3_Attach (kArray3 array, void *items, kType itemType, kSize length0, kSize length1, kSize length2)
| Attaches the array to an external item buffer. More...
kStatus | kArray3_Construct (kArray3 *array, kType itemType, kSize length0, kSize length1, kSize length2, kAlloc allocator)
| Constructs a kArray3 object. More...
kSize | kArray3_Count (kArray3 array)
| Returns the array item count, in elements. More...
void * | kArray3_Data (kArray3 array)
| Returns a pointer to the array item buffer. More...
kSize | kArray3_DataSize (kArray3 array)
| Reports the size, in bytes, of the array item buffer. More...
kStatus | kArray3_Item (kArray3 array, kSize index0, kSize index1, kSize index2, void *item)
| Gets the value of an item. More...
kSize | kArray3_ItemSize (kArray3 array)
| Returns the array item size. More...
kType | kArray3_ItemType (kArray3 array)
| Returns the array item type. More...
kSize | kArray3_Length (kArray3 array, kSize dimension)
| Returns the length of the specified array dimension, in elements. More...
kStatus | kArray3_SetItem (kArray3 array, kSize index0, kSize index1, kSize index2, const void *item)
| Sets the value of an item. More...
kStatus | kArray3_Zero (kArray3 array)
| Sets all array element bits to zero. More...
Public Member Functions inherited from kObject
kAlloc | kObject_Alloc (kObject object)
| Gets the memory allocator associated with this object. More...
kStatus | kObject_Clone (kObject *object, kObject source, kAlloc allocator)
| Constructs a new object by copying an existing object, including any aggregated child elements. More...
kStatus | kObject_Destroy (kObject object)
| Destroys the object. More...
kStatus | kObject_Dispose (kObject object)
| Destroys the object and any aggregated child elements. More...
kBool | kObject_Equals (kObject object, kObject other)
| Determines whether the object is equal to another object. More...
kSize | kObject_HashCode (kObject object)
| Gets a hash code representing the state of this object. More...
kBool | kObject_Is (kObject object, kType type)
| Determines whether this object is an instance of the specified type. More...
kBool | kObject_IsShared (kObject object)
| Reports whether the object is currently shared (reference count greater than one). More...
kStatus | kObject_SetPool (kObject object, kObjectPool pool)
| Sets the object pool associated with this object. More...
kStatus | kObject_Share (kObject object)
| Increments the reference count associated with this object. More...
kSize | kObject_Size (kObject object)
| Estimates the memory consumed by this object, including any aggregated child elements. More...
kType | kObject_Type (kObject object)
| Returns the type of the object. More...
Public Member Functions inherited from kCollection
kSize | kCollection_Count (kCollection collection)
| Gets the collection element count. More...
kIterator | kCollection_GetIterator (kCollection collection)
| Returns an iterator to the first element in the collection. More...
kBool | kCollection_HasNext (kCollection collection, kIterator iterator)
| Determines whether a collection has another item. More...
kType | kCollection_ItemType (kCollection collection)
| Gets the collection element type. More...
void * | kCollection_Next (kCollection collection, kIterator *iterator)
| Gets the next collection element and then advances the iterator. More...

## Related
#define | kArray3_ItemType_(ARRAY) kxArray3_ItemType_(ARRAY)
| Macro version of kArray3_ItemType.
#define | kArray3_ItemSize_(ARRAY) kxArray3_ItemSize_(ARRAY)
| Macro version of kArray3_ItemSize.
#define | kArray3_Length_(ARRAY, DIM) kxArray3_Length_(ARRAY, DIM)
| Macro version of kArray3_Length.
#define | kArray3_Count_(ARRAY) kxArray3_Count_(ARRAY)
| Macro version of kArray3_Count.
#define | kArray3_Data_(ARRAY) kxArray3_Data_(ARRAY)
| Macro version of kArray3_Data.
#define | kArray3_DataSize_(ARRAY) kxArray3_DataSize_(ARRAY)
| Macro version of kArray3_DataSize.
#define | kArray3_At_(ARRAY, I0, I1, I2) kxArray3_At_(ARRAY, I0, I1, I2)
| Macro version of kArray3_At.
#define | kArray3_As_(ARRAY, I0, I1, I2, TYPE) kxArray3_At_(ARRAY, I0, I1, I2)
| Accesses an array element at the specified indices, and casts the value to the specified type. More...
Related inherited from kObject
#define | kObject_Type_(OBJ) kxObject_Type_(OBJ)
| Macro version of kObject_Type.
#define | kObject_Is_(OBJ, TYPE) kxObject_Is_(OBJ, TYPE)
| Macro version of kObject_Is.
#define | kObject_Alloc_(OBJ) kxObject_Allocator_(OBJ)
| Macro version of kObject_Alloc.

The documentation for this class was generated from the following file:

- Data/kArray3.h